# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_navigation_msgs/SmoothPathGoal.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import nav_msgs.msg
import std_msgs.msg

class SmoothPathGoal(genpy.Message):
  _md5sum = "1caed1e728cc133dce5ff7cd134ac8d2"
  _type = "clearpath_navigation_msgs/SmoothPathGoal"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#goal
uint8             CUBIC_SPLINE_SMOOTHER = 1
uint8             DUBINS_SMOOTHER = 2
uint8             GENERIC_SMOOTHER = 3

nav_msgs/Path     path
uint8             type

## Parameters for cubic spline smoother
int32             spline_points_per_unit
int32             spline_skip_points
bool              spline_use_end_conditions
bool              spline_use_middle_conditions

## Parameters for dubins
float64           dubins_turning_radius
float64           dubins_step_size

## Parameters for generic
bool              generic_enable_refinement
int32             generic_refinement_iterations


================================================================================
MSG: nav_msgs/Path
#An array of poses that represents a Path for a robot to follow
Header header
geometry_msgs/PoseStamped[] poses

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  # Pseudo-constants
  CUBIC_SPLINE_SMOOTHER = 1
  DUBINS_SMOOTHER = 2
  GENERIC_SMOOTHER = 3

  __slots__ = ['path','type','spline_points_per_unit','spline_skip_points','spline_use_end_conditions','spline_use_middle_conditions','dubins_turning_radius','dubins_step_size','generic_enable_refinement','generic_refinement_iterations']
  _slot_types = ['nav_msgs/Path','uint8','int32','int32','bool','bool','float64','float64','bool','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       path,type,spline_points_per_unit,spline_skip_points,spline_use_end_conditions,spline_use_middle_conditions,dubins_turning_radius,dubins_step_size,generic_enable_refinement,generic_refinement_iterations

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SmoothPathGoal, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.path is None:
        self.path = nav_msgs.msg.Path()
      if self.type is None:
        self.type = 0
      if self.spline_points_per_unit is None:
        self.spline_points_per_unit = 0
      if self.spline_skip_points is None:
        self.spline_skip_points = 0
      if self.spline_use_end_conditions is None:
        self.spline_use_end_conditions = False
      if self.spline_use_middle_conditions is None:
        self.spline_use_middle_conditions = False
      if self.dubins_turning_radius is None:
        self.dubins_turning_radius = 0.
      if self.dubins_step_size is None:
        self.dubins_step_size = 0.
      if self.generic_enable_refinement is None:
        self.generic_enable_refinement = False
      if self.generic_refinement_iterations is None:
        self.generic_refinement_iterations = 0
    else:
      self.path = nav_msgs.msg.Path()
      self.type = 0
      self.spline_points_per_unit = 0
      self.spline_skip_points = 0
      self.spline_use_end_conditions = False
      self.spline_use_middle_conditions = False
      self.dubins_turning_radius = 0.
      self.dubins_step_size = 0.
      self.generic_enable_refinement = False
      self.generic_refinement_iterations = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs))
      _x = self.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.path.poses:
        _v1 = val1.header
        _x = _v1.seq
        buff.write(_get_struct_I().pack(_x))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v3 = val1.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_B2i2B2dBi().pack(_x.type, _x.spline_points_per_unit, _x.spline_skip_points, _x.spline_use_end_conditions, _x.spline_use_middle_conditions, _x.dubins_turning_radius, _x.dubins_step_size, _x.generic_enable_refinement, _x.generic_refinement_iterations))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.path is None:
        self.path = nav_msgs.msg.Path()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v6 = val1.header
        start = end
        end += 4
        (_v6.seq,) = _get_struct_I().unpack(str[start:end])
        _v7 = _v6.stamp
        _x = _v7
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.frame_id = str[start:end]
        _v8 = val1.pose
        _v9 = _v8.position
        _x = _v9
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v10 = _v8.orientation
        _x = _v10
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.path.poses.append(val1)
      _x = self
      start = end
      end += 32
      (_x.type, _x.spline_points_per_unit, _x.spline_skip_points, _x.spline_use_end_conditions, _x.spline_use_middle_conditions, _x.dubins_turning_radius, _x.dubins_step_size, _x.generic_enable_refinement, _x.generic_refinement_iterations,) = _get_struct_B2i2B2dBi().unpack(str[start:end])
      self.spline_use_end_conditions = bool(self.spline_use_end_conditions)
      self.spline_use_middle_conditions = bool(self.spline_use_middle_conditions)
      self.generic_enable_refinement = bool(self.generic_enable_refinement)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs))
      _x = self.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.path.poses:
        _v11 = val1.header
        _x = _v11.seq
        buff.write(_get_struct_I().pack(_x))
        _v12 = _v11.stamp
        _x = _v12
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v11.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v13 = val1.pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_B2i2B2dBi().pack(_x.type, _x.spline_points_per_unit, _x.spline_skip_points, _x.spline_use_end_conditions, _x.spline_use_middle_conditions, _x.dubins_turning_radius, _x.dubins_step_size, _x.generic_enable_refinement, _x.generic_refinement_iterations))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.path is None:
        self.path = nav_msgs.msg.Path()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v16 = val1.header
        start = end
        end += 4
        (_v16.seq,) = _get_struct_I().unpack(str[start:end])
        _v17 = _v16.stamp
        _x = _v17
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v16.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v16.frame_id = str[start:end]
        _v18 = val1.pose
        _v19 = _v18.position
        _x = _v19
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v20 = _v18.orientation
        _x = _v20
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.path.poses.append(val1)
      _x = self
      start = end
      end += 32
      (_x.type, _x.spline_points_per_unit, _x.spline_skip_points, _x.spline_use_end_conditions, _x.spline_use_middle_conditions, _x.dubins_turning_radius, _x.dubins_step_size, _x.generic_enable_refinement, _x.generic_refinement_iterations,) = _get_struct_B2i2B2dBi().unpack(str[start:end])
      self.spline_use_end_conditions = bool(self.spline_use_end_conditions)
      self.spline_use_middle_conditions = bool(self.spline_use_middle_conditions)
      self.generic_enable_refinement = bool(self.generic_enable_refinement)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B2i2B2dBi = None
def _get_struct_B2i2B2dBi():
    global _struct_B2i2B2dBi
    if _struct_B2i2B2dBi is None:
        _struct_B2i2B2dBi = struct.Struct("<B2i2B2dBi")
    return _struct_B2i2B2dBi
