// Auto-generated. Do not edit!

// (in-package clearpath_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Waypoint = require('./Waypoint.js');
let Task = require('./Task.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Mission {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.name = null;
      this.uuid = null;
      this.waypoints = null;
      this.on_start = null;
      this.on_stop = null;
      this.onav_config = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
      if (initObj.hasOwnProperty('waypoints')) {
        this.waypoints = initObj.waypoints
      }
      else {
        this.waypoints = [];
      }
      if (initObj.hasOwnProperty('on_start')) {
        this.on_start = initObj.on_start
      }
      else {
        this.on_start = [];
      }
      if (initObj.hasOwnProperty('on_stop')) {
        this.on_stop = initObj.on_stop
      }
      else {
        this.on_stop = [];
      }
      if (initObj.hasOwnProperty('onav_config')) {
        this.onav_config = initObj.onav_config
      }
      else {
        this.onav_config = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Mission
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    // Serialize message field [waypoints]
    // Serialize the length for message field [waypoints]
    bufferOffset = _serializer.uint32(obj.waypoints.length, buffer, bufferOffset);
    obj.waypoints.forEach((val) => {
      bufferOffset = Waypoint.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [on_start]
    // Serialize the length for message field [on_start]
    bufferOffset = _serializer.uint32(obj.on_start.length, buffer, bufferOffset);
    obj.on_start.forEach((val) => {
      bufferOffset = Task.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [on_stop]
    // Serialize the length for message field [on_stop]
    bufferOffset = _serializer.uint32(obj.on_stop.length, buffer, bufferOffset);
    obj.on_stop.forEach((val) => {
      bufferOffset = Task.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [onav_config]
    bufferOffset = _serializer.string(obj.onav_config, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Mission
    let len;
    let data = new Mission(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [waypoints]
    // Deserialize array length for message field [waypoints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.waypoints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.waypoints[i] = Waypoint.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [on_start]
    // Deserialize array length for message field [on_start]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.on_start = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.on_start[i] = Task.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [on_stop]
    // Deserialize array length for message field [on_stop]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.on_stop = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.on_stop[i] = Task.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [onav_config]
    data.onav_config = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += _getByteLength(object.name);
    length += _getByteLength(object.uuid);
    object.waypoints.forEach((val) => {
      length += Waypoint.getMessageSize(val);
    });
    object.on_start.forEach((val) => {
      length += Task.getMessageSize(val);
    });
    object.on_stop.forEach((val) => {
      length += Task.getMessageSize(val);
    });
    length += _getByteLength(object.onav_config);
    return length + 24;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_navigation_msgs/Mission';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '0d17e8fd2d71b44f2220b0d819a9ee9b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition for an OutdoorNav mission
    
    std_msgs/Header header
    
    # The human-readable name of this mission
    string name
    
    # A UUID string used to uniquely identify this mission
    string uuid
    
    # The ordered list of Waypoints that make up the mission
    clearpath_navigation_msgs/Waypoint[] waypoints
    
    # An array of Tasks to execute on Mission start
    clearpath_navigation_msgs/Task[] on_start
    
    # An array of Tasks to execute on Mission stop
    # These Tasks will execute regardless of mission success or failure
    clearpath_navigation_msgs/Task[] on_stop
    
    # Configuration parameters for the mission
    # Additional details TBD
    string onav_config
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Waypoint
    # A single Waypoint along a Mission
    
    # A UUID string to uniquely identify this Waypoint
    string uuid
    
    # The human-readable name of this Waypoint
    string name
    
    # The latitude (in degrees) of this Waypoint
    float64 latitude
    
    # The longitude (in degrees) of this Waypoint
    float64 longitude
    
    # The compass heading (in degrees) of this Waypoint
    float64 heading
    
    # A radius in meters indicating the acceptable radius from the target location
    # Posititon tolerance is disabled if this value is negative
    float64 position_tolerance
    
    # A tolerance in degrees indicating the acceptable deviation from the heading
    # Heading tolerance is disabled if this value is negative
    float64 yaw_tolerance
    
    # The ordered set of Tasks to execute once the goal position & orientation are reached
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Task
    # A single task that can be executed at a Waypoint
    
    # The human-readable name of this task
    string name
    
    # A UUID string to uniquely identify this Task
    string uuid
    
    # The ROS action that this task executes
    string action_server_name
    
    # The version of this task
    string version
    
    # Numerical/boolean data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    float64[] floats
    
    # String data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    string[] strings
    
    # Boolean value which determines whether a mission using this task can continue
    # if this task fails to execute
    bool allow_failure
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Mission(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    if (msg.waypoints !== undefined) {
      resolved.waypoints = new Array(msg.waypoints.length);
      for (let i = 0; i < resolved.waypoints.length; ++i) {
        resolved.waypoints[i] = Waypoint.Resolve(msg.waypoints[i]);
      }
    }
    else {
      resolved.waypoints = []
    }

    if (msg.on_start !== undefined) {
      resolved.on_start = new Array(msg.on_start.length);
      for (let i = 0; i < resolved.on_start.length; ++i) {
        resolved.on_start[i] = Task.Resolve(msg.on_start[i]);
      }
    }
    else {
      resolved.on_start = []
    }

    if (msg.on_stop !== undefined) {
      resolved.on_stop = new Array(msg.on_stop.length);
      for (let i = 0; i < resolved.on_stop.length; ++i) {
        resolved.on_stop[i] = Task.Resolve(msg.on_stop[i]);
      }
    }
    else {
      resolved.on_stop = []
    }

    if (msg.onav_config !== undefined) {
      resolved.onav_config = msg.onav_config;
    }
    else {
      resolved.onav_config = ''
    }

    return resolved;
    }
};

module.exports = Mission;
