// Auto-generated. Do not edit!

// (in-package clearpath_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Mission = require('./Mission.js');
let Waypoint = require('./Waypoint.js');

//-----------------------------------------------------------

class MissionGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.mission = null;
      this.from_start = null;
      this.start_waypoint = null;
    }
    else {
      if (initObj.hasOwnProperty('mission')) {
        this.mission = initObj.mission
      }
      else {
        this.mission = new Mission();
      }
      if (initObj.hasOwnProperty('from_start')) {
        this.from_start = initObj.from_start
      }
      else {
        this.from_start = false;
      }
      if (initObj.hasOwnProperty('start_waypoint')) {
        this.start_waypoint = initObj.start_waypoint
      }
      else {
        this.start_waypoint = new Waypoint();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MissionGoal
    // Serialize message field [mission]
    bufferOffset = Mission.serialize(obj.mission, buffer, bufferOffset);
    // Serialize message field [from_start]
    bufferOffset = _serializer.bool(obj.from_start, buffer, bufferOffset);
    // Serialize message field [start_waypoint]
    bufferOffset = Waypoint.serialize(obj.start_waypoint, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MissionGoal
    let len;
    let data = new MissionGoal(null);
    // Deserialize message field [mission]
    data.mission = Mission.deserialize(buffer, bufferOffset);
    // Deserialize message field [from_start]
    data.from_start = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [start_waypoint]
    data.start_waypoint = Waypoint.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Mission.getMessageSize(object.mission);
    length += Waypoint.getMessageSize(object.start_waypoint);
    return length + 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_navigation_msgs/MissionGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '6929f320324cf7e0794d21662ea1f558';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Action definition for sending a mission to the Clearpath OutdoorNav software
    
    # goal
    clearpath_navigation_msgs/Mission mission
    
    # from_start = True -> Forces the mission to execute from the beginning
    bool from_start
    
    # If from_start = False, mission will be executed from the start_waypoint specified.
    # If from_start = False and no start_waypoint is specified then autonomy will pick the closest waypoint
    clearpath_navigation_msgs/Waypoint start_waypoint
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Mission
    # Message definition for an OutdoorNav mission
    
    std_msgs/Header header
    
    # The human-readable name of this mission
    string name
    
    # A UUID string used to uniquely identify this mission
    string uuid
    
    # The ordered list of Waypoints that make up the mission
    clearpath_navigation_msgs/Waypoint[] waypoints
    
    # An array of Tasks to execute on Mission start
    clearpath_navigation_msgs/Task[] on_start
    
    # An array of Tasks to execute on Mission stop
    # These Tasks will execute regardless of mission success or failure
    clearpath_navigation_msgs/Task[] on_stop
    
    # Configuration parameters for the mission
    # Additional details TBD
    string onav_config
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Waypoint
    # A single Waypoint along a Mission
    
    # A UUID string to uniquely identify this Waypoint
    string uuid
    
    # The human-readable name of this Waypoint
    string name
    
    # The latitude (in degrees) of this Waypoint
    float64 latitude
    
    # The longitude (in degrees) of this Waypoint
    float64 longitude
    
    # The compass heading (in degrees) of this Waypoint
    float64 heading
    
    # A radius in meters indicating the acceptable radius from the target location
    # Posititon tolerance is disabled if this value is negative
    float64 position_tolerance
    
    # A tolerance in degrees indicating the acceptable deviation from the heading
    # Heading tolerance is disabled if this value is negative
    float64 yaw_tolerance
    
    # The ordered set of Tasks to execute once the goal position & orientation are reached
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Task
    # A single task that can be executed at a Waypoint
    
    # The human-readable name of this task
    string name
    
    # A UUID string to uniquely identify this Task
    string uuid
    
    # The ROS action that this task executes
    string action_server_name
    
    # The version of this task
    string version
    
    # Numerical/boolean data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    float64[] floats
    
    # String data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    string[] strings
    
    # Boolean value which determines whether a mission using this task can continue
    # if this task fails to execute
    bool allow_failure
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MissionGoal(null);
    if (msg.mission !== undefined) {
      resolved.mission = Mission.Resolve(msg.mission)
    }
    else {
      resolved.mission = new Mission()
    }

    if (msg.from_start !== undefined) {
      resolved.from_start = msg.from_start;
    }
    else {
      resolved.from_start = false
    }

    if (msg.start_waypoint !== undefined) {
      resolved.start_waypoint = Waypoint.Resolve(msg.start_waypoint)
    }
    else {
      resolved.start_waypoint = new Waypoint()
    }

    return resolved;
    }
};

module.exports = MissionGoal;
