// Auto-generated. Do not edit!

// (in-package clearpath_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let WaypointStatus = require('./WaypointStatus.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class MissionStatus {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.name = null;
      this.uuid = null;
      this.waypoints = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
      if (initObj.hasOwnProperty('waypoints')) {
        this.waypoints = initObj.waypoints
      }
      else {
        this.waypoints = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MissionStatus
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    // Serialize message field [waypoints]
    // Serialize the length for message field [waypoints]
    bufferOffset = _serializer.uint32(obj.waypoints.length, buffer, bufferOffset);
    obj.waypoints.forEach((val) => {
      bufferOffset = WaypointStatus.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MissionStatus
    let len;
    let data = new MissionStatus(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [waypoints]
    // Deserialize array length for message field [waypoints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.waypoints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.waypoints[i] = WaypointStatus.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += _getByteLength(object.name);
    length += _getByteLength(object.uuid);
    object.waypoints.forEach((val) => {
      length += WaypointStatus.getMessageSize(val);
    });
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_navigation_msgs/MissionStatus';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '38e6e8d596fedae2309ab39c49223ff4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition for an OutdoorNav mission
    
    std_msgs/Header header
    
    string name
    string uuid
    
    clearpath_navigation_msgs/WaypointStatus[] waypoints
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_navigation_msgs/WaypointStatus
    # The x and y coordinates of a specific waypoint in map (utm) coordinates.
    
    clearpath_navigation_msgs/Waypoint waypoint
    
    bool visited
    bool skipped
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Waypoint
    # A single Waypoint along a Mission
    
    # A UUID string to uniquely identify this Waypoint
    string uuid
    
    # The human-readable name of this Waypoint
    string name
    
    # The latitude (in degrees) of this Waypoint
    float64 latitude
    
    # The longitude (in degrees) of this Waypoint
    float64 longitude
    
    # The compass heading (in degrees) of this Waypoint
    float64 heading
    
    # A radius in meters indicating the acceptable radius from the target location
    # Posititon tolerance is disabled if this value is negative
    float64 position_tolerance
    
    # A tolerance in degrees indicating the acceptable deviation from the heading
    # Heading tolerance is disabled if this value is negative
    float64 yaw_tolerance
    
    # The ordered set of Tasks to execute once the goal position & orientation are reached
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Task
    # A single task that can be executed at a Waypoint
    
    # The human-readable name of this task
    string name
    
    # A UUID string to uniquely identify this Task
    string uuid
    
    # The ROS action that this task executes
    string action_server_name
    
    # The version of this task
    string version
    
    # Numerical/boolean data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    float64[] floats
    
    # String data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    string[] strings
    
    # Boolean value which determines whether a mission using this task can continue
    # if this task fails to execute
    bool allow_failure
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MissionStatus(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    if (msg.waypoints !== undefined) {
      resolved.waypoints = new Array(msg.waypoints.length);
      for (let i = 0; i < resolved.waypoints.length; ++i) {
        resolved.waypoints[i] = WaypointStatus.Resolve(msg.waypoints[i]);
      }
    }
    else {
      resolved.waypoints = []
    }

    return resolved;
    }
};

module.exports = MissionStatus;
