// Auto-generated. Do not edit!

// (in-package clearpath_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class MotionState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.motion = null;
      this.indicator = null;
      this.direction = null;
    }
    else {
      if (initObj.hasOwnProperty('motion')) {
        this.motion = initObj.motion
      }
      else {
        this.motion = 0;
      }
      if (initObj.hasOwnProperty('indicator')) {
        this.indicator = initObj.indicator
      }
      else {
        this.indicator = 0;
      }
      if (initObj.hasOwnProperty('direction')) {
        this.direction = initObj.direction
      }
      else {
        this.direction = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MotionState
    // Serialize message field [motion]
    bufferOffset = _serializer.uint8(obj.motion, buffer, bufferOffset);
    // Serialize message field [indicator]
    bufferOffset = _serializer.uint8(obj.indicator, buffer, bufferOffset);
    // Serialize message field [direction]
    bufferOffset = _serializer.uint8(obj.direction, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MotionState
    let len;
    let data = new MotionState(null);
    // Deserialize message field [motion]
    data.motion = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [indicator]
    data.indicator = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [direction]
    data.direction = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_navigation_msgs/MotionState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b05c434898c15953bcc0fb00dd863be1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Motion state message to indicate the current motion, expected motion and the direction of travel of the robot.
    
    # State pertaining to current motion of the robot.
    uint8 MOTION_NORMAL=10
    uint8 MOTION_STOPPED=11
    uint8 MOTION_REVERSE=12
    uint8 MOTION_SLOWING=13 # Currently unused
    uint8 motion
    
    # State pertaining to the robot's movement along the path. Predictive, ie state
    # will be INDICATOR_LEFT_TURN if in or approaching a left turn.
    uint8 INDICATOR_NORMAL=20
    uint8 INDICATOR_LEFT_TURN=21
    uint8 INDICATOR_RIGHT_TURN=22
    uint8 INDICATOR_CLOCKWISE=23
    uint8 INDICATOR_COUNTERCLOCKWISE=24
    uint8 INDICATOR_HAZARD=25 # Currently unused
    uint8 indicator
    
    # Direction of travel of the robot relative to its physical forward direction.
    uint8 DIRECTION_FORWARD=30
    uint8 DIRECTION_REVERSE=31
    uint8 direction
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MotionState(null);
    if (msg.motion !== undefined) {
      resolved.motion = msg.motion;
    }
    else {
      resolved.motion = 0
    }

    if (msg.indicator !== undefined) {
      resolved.indicator = msg.indicator;
    }
    else {
      resolved.indicator = 0
    }

    if (msg.direction !== undefined) {
      resolved.direction = msg.direction;
    }
    else {
      resolved.direction = 0
    }

    return resolved;
    }
};

// Constants for message
MotionState.Constants = {
  MOTION_NORMAL: 10,
  MOTION_STOPPED: 11,
  MOTION_REVERSE: 12,
  MOTION_SLOWING: 13,
  INDICATOR_NORMAL: 20,
  INDICATOR_LEFT_TURN: 21,
  INDICATOR_RIGHT_TURN: 22,
  INDICATOR_CLOCKWISE: 23,
  INDICATOR_COUNTERCLOCKWISE: 24,
  INDICATOR_HAZARD: 25,
  DIRECTION_FORWARD: 30,
  DIRECTION_REVERSE: 31,
}

module.exports = MotionState;
