// Auto-generated. Do not edit!

// (in-package clearpath_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PointVector = require('./PointVector.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class ScanPoints {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.frames_vector = null;
      this.cloud_vector = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('frames_vector')) {
        this.frames_vector = initObj.frames_vector
      }
      else {
        this.frames_vector = [];
      }
      if (initObj.hasOwnProperty('cloud_vector')) {
        this.cloud_vector = initObj.cloud_vector
      }
      else {
        this.cloud_vector = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ScanPoints
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [frames_vector]
    bufferOffset = _arraySerializer.string(obj.frames_vector, buffer, bufferOffset, null);
    // Serialize message field [cloud_vector]
    // Serialize the length for message field [cloud_vector]
    bufferOffset = _serializer.uint32(obj.cloud_vector.length, buffer, bufferOffset);
    obj.cloud_vector.forEach((val) => {
      bufferOffset = PointVector.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ScanPoints
    let len;
    let data = new ScanPoints(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [frames_vector]
    data.frames_vector = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [cloud_vector]
    // Deserialize array length for message field [cloud_vector]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.cloud_vector = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.cloud_vector[i] = PointVector.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.frames_vector.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    object.cloud_vector.forEach((val) => {
      length += PointVector.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_navigation_msgs/ScanPoints';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '05369a59394b51217957f0e7c4e995db';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition for the detection points used by the navigation that relate to the detected obstacles.
    
    std_msgs/Header header
    
    string[] frames_vector
    clearpath_navigation_msgs/PointVector[] cloud_vector
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_navigation_msgs/PointVector
    # Vector of point vectors (for GUI)
    std_msgs/Header header
    
    clearpath_navigation_msgs/Vector2D[] cloud
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Vector2D
    # 2D Vector of floats (used for GUI)
    
    float32[2] point
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ScanPoints(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.frames_vector !== undefined) {
      resolved.frames_vector = msg.frames_vector;
    }
    else {
      resolved.frames_vector = []
    }

    if (msg.cloud_vector !== undefined) {
      resolved.cloud_vector = new Array(msg.cloud_vector.length);
      for (let i = 0; i < resolved.cloud_vector.length; ++i) {
        resolved.cloud_vector[i] = PointVector.Resolve(msg.cloud_vector[i]);
      }
    }
    else {
      resolved.cloud_vector = []
    }

    return resolved;
    }
};

module.exports = ScanPoints;
